#pragma once

#include <vector>
#include <string>
#include <cmath>
#include <cassert>

template<typename A>
class alloc
{
public:
  static A* allocate()
  {
    return new A;
  }
  static void destroy(A* a)
  {
    delete a;
  }
};

template<typename A, typename allocator = alloc<A> >
class foo_base
{
public:
  foo_base(A a_)
  {
    a = allocator::allocate();
  }
  ~foo_base()
  {
    allocator::destroy(a);
  }

  bool foo_bar_it()
  {
    return a != nullptr;
  }

  bool empty();
private:
  A* a;
};

template<typename A, typename allocator>
bool foo_base<A,allocator>::empty()
{
  return !*a;
}

template<typename A>
class foo : public foo_base<A>
{
public:
  foo(A a_) : foo_base<A>(a_) { a = static_cast<A>(std::sqrt(double(a_))); };
  ~foo() { this->foo_base<A>::~foo_base(); };

  void barit() { foo_bar_it(); };
  bool empty()
  {
    return foo_base<A>::empty();
  }
private:
  A a;
  //char a;
};